// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Character.h"
#include "LMPlayer.generated.h"

class UCameraComponent;
class ULMWeaponManager;

class ALMAmmo;

UCLASS()
class LEGUMEMIX_API ALMPlayer : public ACharacter
{
	GENERATED_BODY()

public:
	// Sets default values for this character's properties
	ALMPlayer();
	virtual void Tick(float DeltaTime) override;
	virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;
	
	UFUNCTION()
	void PickUpAmmo(ALMAmmo* Ammo);

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:	
	UFUNCTION(BlueprintCallable)
	ULMWeaponManager* GetWeaponManager() { return WeaponManager; }

	UFUNCTION(BlueprintCallable)
	void SetWeaponManager(ULMWeaponManager* Manager);

private:
	UPROPERTY(EditAnywhere, BlueprintReadOnly, Category="Legumix", meta = (AllowPrivateAccess = true))
	TObjectPtr<ULMWeaponManager> WeaponManager;

	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category="Legumix", meta = (AllowPrivateAccess = true))
	TObjectPtr<USkeletalMeshComponent> WeaponSkeletalMeshComponent;

	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category="Legumix", meta = (AllowPrivateAccess = true))
	TObjectPtr<UCameraComponent> Camera;
};
